-- WikNukem Forever
-- Copyright (C) 2009 Noé Falzon <firstname.lastname@aliceadsl.fr>

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

package.path = package.path .. ";./evol/?.lua"
package.cpath = package.cpath .. ";./evol/?.so"

require "evol"

require "utils"

require "menu"
require "game"
require "win"
require "die"

EC = evol.curses

EC.init(80,24,"DejaVuSansMono.ttf",13)

evol.showCursor(false)

-- load sounds

sfx = {}

sfx.tidi =  evol.loadSound("sfx/tididididi.wav")
sfx.step =  evol.loadSound("sfx/step.wav")
sfx.sg =  evol.loadSound("sfx/sg.wav")
sfx.mg =  evol.loadSound("sfx/mg.wav")
sfx.lose =  evol.loadSound("sfx/lose.wav")
sfx.long =  evol.loadSound("sfx/long.wav")
sfx.load =  evol.loadSound("sfx/load.wav")
sfx.intro =  evol.loadSound("sfx/intro.wav")
sfx.dong =  evol.loadSound("sfx/dong.wav")
sfx.creepy =  evol.loadSound("sfx/creepy.wav")
sfx.simple =  evol.loadSound("sfx/simple.wav")
sfx.robodie =  evol.loadSound("sfx/robodie.wav")

function main()

	quit = false

	while not quit do	
		
		dt,fps,t = evol.timer(25)
		
		evol.input {
			gameMode.keydown,
			gameMode.keyup,

		}
		
		if gameMode.update then
			gameMode.update(dt,fps,t)
		end
		
		evol.flip()
	end

	evol.quit()
end

-- Game mode manager
setGameMode = function(mode)
	gameMode = mode
	mode.init()
end

setGameMode(menu)
main()
